<?php declare(strict_types=1);

namespace Convo\Proto;


use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Psr\Http\Message\ResponseInterface;

class TestUserAuthMiddleware implements \Psr\Http\Server\MiddlewareInterface
{	
	
	/**
	 * @var \Psr\Log\LoggerInterface
	 */
	private $_logger;
	
	/**
	 * @var \Convo\Core\IAdminUserDataProvider
	 */
	private $_adminUserDataProvider;
	
	public function __construct( \Psr\Log\LoggerInterface $logger, $adminUserDataProvider)
	{
		$this->_logger	=	$logger;
		$this->_adminUserDataProvider	=	$adminUserDataProvider;
	}
	
	public function process( ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
	{
	    $xConvoTestAuth = $request->getHeaderLine('X-Convo-Test-Auth') ;

        $this->_logger->debug( 'TestAdminUserAuthMiddleware');
        $this->_logger->debug( $xConvoTestAuth);
        if (!empty($xConvoTestAuth) && $xConvoTestAuth === 'true') {
            $user = $this->_adminUserDataProvider->findUser('test');

            $this->_logger->debug( 'Setting test user');
            $request = $request->withAttribute( \Convo\Core\IAdminUser::class, $user);
        }

		return $handler->handle( $request);
	}
	
	// UTIL
	public function __toString()
	{
		return get_class( $this).'[]';
	}
}