<?php
    require_once('../library/autoload.php');
    require_once('../common/__config.php');

    if ( !defined( 'CONVO_BASE_URL')) {
        throw new \Exception( 'CONVO_BASE_URL is not defined!');
    }

    if ( !defined( 'CONVO_PUBLIC_REST_BASE_URL')) {
        define( 'CONVO_PUBLIC_REST_BASE_URL', CONVO_BASE_URL.'/rest_public/convo/v1');
    }

    if ( !defined( 'PROTO_DEMO_SERVICE')) {
        define( 'PROTO_DEMO_SERVICE', '');
    }

    if (!defined('PROTO_ANGULARJS_LOG_ENABLED')) {
        define('PROTO_ANGULARJS_LOG_ENABLED', false);
    }
?>

<!DOCTYPE html>
<html lang="en" ng-app="proto.admin" style="font-size: 16px;">

    <head>
        <meta name="robots" content="noindex">
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
        <title><?php echo PROTO_APP_TITLE ?></title>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/themes/smoothness/jquery-ui.css">
<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>

<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.8.2/angular.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.8.2/angular-animate.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.8.2/angular-cookies.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.8.2/angular-sanitize.min.js"></script>

<script src="https://unpkg.com/react@16.14.0/umd/react.development.js" crossorigin></script>
<script src="https://unpkg.com/react-dom@16.14.0/umd/react-dom.development.js" crossorigin></script>
  

 <script type="text/javascript" src="./vendor.js?1aa7141d00c6ac6400b8"></script>

 <script type="text/javascript" src="./main.js?1aa7141d00c6ac6400b8"></script>


    <script>
    var appModule   =   angular.module('proto.admin');
    appModule.constant( 'CONVO_PUBLIC_API_BASE_URL', '<?php echo CONVO_PUBLIC_REST_BASE_URL ?>');
    appModule.constant( 'CONVO_ADMIN_API_BASE_URL', '<?php echo CONVO_BASE_URL ?>/rest_admin/convo/v1');

    appModule.constant( 'PROTO_ADMIN_API_BASE_URL', '<?php echo CONVO_BASE_URL ?>/rest_admin/proto/v1');
    appModule.constant( 'PROTO_PUBLIC_API_BASE_URL', '<?php echo CONVO_BASE_URL ?>/rest_public/proto/v1');
    appModule.constant( 'PROTO_HOME_CHAT_SERVICE_ID', '<?php echo PROTO_DEMO_SERVICE ?>');
	appModule.constant( 'PROTO_DEBUG_ENABLED', <?php echo PROTO_ANGULARJS_LOG_ENABLED ? 'true':'false'?>);

    </script>

    </head>
    <body ng-controller="MainController">

	<alert-indicator></alert-indicator>

    <!-- Navigation -->
    <adm-navigation user="{{ getUserObject() }}"></adm-navigation>

    <loading-indicator></loading-indicator>

    <!-- Page Content -->
    <div class="convo-proto-content" ui-view autoscroll="false">


    </div>
    <!-- /.container -->

	<hr style="margin-top: 0">

	<footer>
		<p style="text-align: center;"><strong>Convoworks Prototype v1.18.0</strong> <br/> &copy; ZEF Development 2020
	</footer>

    </body>

</html>
